"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.binder = void 0;
function binder(target) {
    const methods = {};
    return new Proxy(target, {
        has(_target, prop) {
            return methods.hasOwnProperty(prop);
        },
        get(targ, prop) {
            if (methods[prop] === undefined && targ[prop]) {
                const method = targ[prop];
                if (typeof method === 'function') {
                    methods[prop] = method.bind(targ);
                }
            }
            return methods[prop];
        },
        set() {
            return true;
        },
        deleteProperty(_target, prop) {
            delete methods[prop];
            return true;
        },
        ownKeys() {
            return [];
        }
    });
}
exports.binder = binder;
//# sourceMappingURL=binder.js.map