import { EventEmitter } from './';
import type { GameStatus } from './';
export declare type GameEvent = {
    path: string;
    category: string;
    key: string;
    val: any;
};
declare type GameEventTypes = {
    [key: string]: GameEvent;
};
export declare class GameEvents extends EventEmitter<GameEventTypes> {
    #private;
    constructor(features: string[], gameStatus: GameStatus);
    /** Copy of current state, both info updates and last event values */
    get state(): Record<string, any>;
    /**
     * Call overwolf.games.events.setRequiredFeatures and bind listeners
     * @see https://overwolf.github.io/docs/api/overwolf-games-events#setrequiredfeaturesfeatures-callback
     */
    start(): Promise<void>;
    private _start;
    /** Remove all listeners and clear the {@link state} */
    stop(): Promise<void>;
    private _stop;
    /** Remove all listeners */
    destroy(): void;
    private removeListeners;
    private setListeners;
    private onError;
    /** Wrapper for overwolf.games.events.getInfo */
    getInfo<T>(): Promise<T>;
    private onGotInfo;
    private onInfoUpdate;
    private onNewEvent;
    private _setRequiredFeatures;
    private setRequiredFeatures;
}
export {};
//# sourceMappingURL=game-events.d.ts.map