/// <reference types="@overwolf/types" />
import { EventEmitter } from './event-emitter';
declare type GameStatusEventTypes = {
    focus: boolean;
    running: boolean;
    resolutionChanged: overwolf.games.RunningGameInfo | null;
    gameChanged: overwolf.games.RunningGameInfo | null;
    changed: overwolf.games.RunningGameInfo | null;
};
export declare class GameStatus extends EventEmitter<GameStatusEventTypes> {
    #private;
    isInFocus: boolean;
    isRunning: boolean;
    gameInfo: overwolf.games.RunningGameInfo | null;
    constructor();
    private start;
    /** Remove all listeners */
    destroy(): void;
    private onGameInfoUpdated;
    private setGameInfo;
    /**
     * Check whenter the game running matches the passed GameID
     * @param id Overwolf GameID
     */
    gameIs(id: number): boolean;
    /** Get gameID of current or last running game */
    get gameID(): number | null;
}
export {};
//# sourceMappingURL=game-status.d.ts.map