/// <reference types="@overwolf/types" />
import { EventEmitter } from './event-emitter';
export declare type HotkeyChangedEvent = {
    name: string;
    binding: string;
    gameId?: number;
};
export declare type HotkeyName = string;
declare type HotkeyEventTypes = {
    changed: HotkeyChangedEvent;
    pressed: HotkeyName;
};
export declare class HotkeyService extends EventEmitter<HotkeyEventTypes> {
    #private;
    constructor();
    private start;
    /** Remove all listeners */
    destroy(): void;
    getHotkeyBinding(hotkeyName: string, gameId?: number): string | null;
    private getHotkeys;
    private updateHotkeys;
    private handleHotkeyChanged;
    private handleHotkeyPressed;
    /**
     * Wrapper for overwolf.settings.hotkeys.assign
     * @see https://overwolf.github.io/docs/api/overwolf-settings-hotkeys#assignhotkey-callback
     */
    assignHotkey(assignHotkey: overwolf.settings.hotkeys.AssignHotkeyObject): Promise<overwolf.Result>;
    /**
     * Wrapper for overwolf.settings.hotkeys.unassign
     * @see https://overwolf.github.io/docs/api/overwolf-settings-hotkeys#unassignhotkey-callback
     */
    unassignHotkey(unassignHotkey: overwolf.settings.hotkeys.UnassignHotkeyObject): Promise<overwolf.Result>;
}
export {};
//# sourceMappingURL=hotkeys-service.d.ts.map