export declare const WindowTunnel: {
    /**
     * Set a global object that will be shared between all windows.
     * This should ONLY be called from the window set as "start_window"
     * in manifest.json (background window)
     * @param key Global name for tunneled object
     * @param value Object to tunnel
     */
    set<T>(key: string, value: T): void;
    /**
     * Get a global tunneled object.
     * @param key Global name for tunneled object
     * @returns Tunneled object
     */
    get<T_1>(key: string): T_1;
};
//# sourceMappingURL=window-tunnel.d.ts.map